function [result] = keep_only_points_inside_the_bboxes(x, y, oi, oj, parts_data, part_in_process)

x_est_1 = [];
y_est_1 = [];
x_est_2 = [];
y_est_2 = [];

result.part_in_process = part_in_process;

for j = part_in_process
    
%     block = [90, 289, 168, 351];
    bbox = parts_data.parts(j).rect;
    block = [bbox(1), bbox(2), bbox(1)+bbox(3), bbox(2)+bbox(4)];
    
    ind = find( x(1,:) > block(1) );
    r1 = x(1,ind);
    s1 = y(1,ind);
    r2 = x(2,ind);
    s2 = y(2,ind);
    ind = find( r1(1,:) < block(3) );
    r1 = r1(1,ind);
    s1 = s1(1,ind);
    r2 = r2(1,ind);
    s2 = s2(1,ind);

    ind = find( s1(1,:) > block(2) );
    r1 = r1(1,ind);
    s1 = s1(1,ind);
    r2 = r2(1,ind);
    s2 = s2(1,ind);
    ind = find( s1(1,:) < block(4) );
    r1 = r1(1,ind);
    s1 = s1(1,ind);
    r2 = r2(1,ind);
    s2 = s2(1,ind);
    
    newK = length(r1);
    
    
%     t_r1 = r1;
%     t_s1 = s1;
%     t_r2 = r2;
%     t_s2 = s2;
    
    % -------- Remove the OUTLIERS -----------
    % Remove features that are too far
    radius_nh = 50;
    
    cp = struct('index', {[]});
    ncp = 0;
    center = [mean(r1); mean(s1)];
%     [cp, ncp] = close_points(center, r2-oj, s2-oi, radius_nh);
    [cp, ncp] = close_points(center, r2, s2, radius_nh);

    t_r1 = r1(cp.index);
    t_s1 = s1(cp.index);
    t_r2 = r2(cp.index);
    t_s2 = s2(cp.index);

    newK = ncp;
    % ----------------------------------------
    % Remove smaller groups of features
    radius = 50;
    
    cp = struct('index', {[]});
    ncp = zeros(1,newK);
    for m = 1:newK        
        center = [t_r2(m); t_s2(m)];
        [cp(m), ncp(m)] = close_points(center, t_r2, t_s2, radius);
    end
    
    [max_ncp, max_ncp_ind] = max(ncp);
    nans = NaN * ones(1,max_ncp);

    n_r1 = t_r1(cp(max_ncp_ind).index);
    n_s1 = t_s1(cp(max_ncp_ind).index);
    n_r2 = t_r2(cp(max_ncp_ind).index);
    n_s2 = t_s2(cp(max_ncp_ind).index);

%     % all corresponding matched feature positions for all joints
%     if (max_ncp ~= 0)
%         if (j == parts_data.parts_used(1))
%             temp_r = [n_r1 ; n_r2; nans];
%             temp_s = [n_s1 ; n_s2; nans];
% 
%             r(:,:) = temp_r;
%             s(:,:) = temp_s;
%         else        
%             temp_r = [n_r1 ; n_r2; nans];
%             temp_s = [n_s1 ; n_s2; nans];
% 
%             r(:,1:end+max_ncp) = [r(:,:), temp_r];
%             s(:,1:end+max_ncp) = [s(:,:), temp_s];
%         end
%     end    
    
    dx_est = parts_data.parts(j).partspose(3) - mean(n_r1);
    dy_est = parts_data.parts(j).partspose(4) - mean(n_s1);
    
    x_est_1 = parts_data.parts(j).partspose(3);
    y_est_1 = parts_data.parts(j).partspose(4);

    x_est_2 = dx_est + mean(n_r2);
    y_est_2 = dy_est + mean(n_s2);
    
    
end


result.x_est_1 = x_est_1;
result.y_est_1 = y_est_1;
result.x_est_2 = x_est_2;
result.y_est_2 = y_est_2;



function [cp, ncp] = close_points(center, x, y, radius)
% Remember return value of 'ncp' will be atleast '1' because argument
% 'center' is also present in the '[x,y]' co-ordinates. If not then
% this argument is not 'true'. Make sure for your specific problem!

K = length(x);
ncp = 0;
cp.index = [];

for i = 1:K
    if ( sqrt( (x(i)-center(1))^2 + (y(i)-center(2))^2 ) < radius )
        ncp = ncp + 1;
        cp.index = [cp.index, i];
    end        
end



